#
# spec file for package quagga (Version 0.99.9)
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           quagga
BuildRequires:  net-snmp-devel pam-devel readline-devel
Version:        0.99.9
Release:        14.7.1
PreReq:         %insserv_prereq %fillup_prereq /usr/sbin/useradd /usr/sbin/groupadd
PreReq:         %install_info_prereq
Provides:       zebra
Obsoletes:      zebra
AutoReqProv:    on
License:        LGPL v2.1 or later
Group:          Productivity/Networking/Routing
Url:            http://www.quagga.net
Summary:        Free Routing Software (for BGP, OSPF and RIP, for example)
Source:         %{name}-%{version}.tar.bz2
Source1:        rc.tar.bz2
Source2:        quagga.pam
Patch0:         %{name}-%{version}-warnings.patch
Patch1:         %{name}-%{version}-badshift.patch
Patch2:         %{name}-%{version}-bgpd-asn-dos.patch
Patch3:         %{name}-0.99.9-CVE-2010-2948.patch
Patch4:         %{name}-0.99.9-CVE-2010-2949.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Quagga is a routing software suite, providing implementations of
OSPFv2, OSPFv3, RIP v1 and v2, RIPv3 and BGPv4 for Unix platforms,
particularly FreeBSD and Linux and also NetBSD, to mention a few.
Quagga is a fork of GNU Zebra which was developed by Kunihiro Ishiguro.
The Quagga tree aims to build a more involved community around Quagga
than the current centralised model of GNU Zebra.



Authors:
--------
    Kunihiro Ishiguro <kunihiro@zebra.org>
    Toshiaki Takada <takada@zebra.org>
    Yasuhiro Ohara <yasu@sfc.wide.ad.jp>
    Alex D. Zinin <azinin@hotmail.com>
    Gleb Natapov <gleb@nbase.co.il>
    Akihiro Mizutani <mizutani@dml.com>

%package      devel
License:        LGPL v2.1 or later
Summary:        Free Routing Software (for BGP, OSPF and RIP, for example)
Requires:       %{name} = %{version}
Group:          Productivity/Networking/Routing

%description devel
Quagga is a routing software suite, providing implementations of
OSPFv2, OSPFv3, RIP v1 and v2, RIPv3 and BGPv4 for Unix platforms,
particularly FreeBSD and Linux and also NetBSD, to mention a few.
Quagga is a fork of GNU Zebra which was developed by Kunihiro Ishiguro.
The Quagga tree aims to build a more involved community around Quagga
than the current centralised model of GNU Zebra.



Authors:
--------
    Kunihiro Ishiguro <kunihiro@zebra.org>
    Toshiaki Takada <takada@zebra.org>
    Yasuhiro Ohara <yasu@sfc.wide.ad.jp>
    Alex D. Zinin <azinin@hotmail.com>
    Gleb Natapov <gleb@nbase.co.il>
    Akihiro Mizutani <mizutani@dml.com>

%prep
%setup -q -a 1
%patch0
%patch1
%patch2
%patch3 -p 1
%patch4 -p 1

%build
if ! ls  /proc/net/{dev,route,snmp} >/dev/null; then
	echo "ERROR: /proc is not mounted" >&2;
	exit 1;
fi	
autoreconf --force --install
CFLAGS="$RPM_OPT_FLAGS" \
./configure \
    --enable-vtysh \
    --enable-rtadv \
    --enable-snmp \
    --enable-ipv6 \
    --with-libpam \
    --enable-netlink \
    --prefix=/usr \
    --sysconfdir=/etc/quagga \
    --mandir=%{_mandir} \
    --infodir=%{_infodir} \
    --localstatedir=/var/run/quagga \
    --enable-multipath=0 \
    --libdir=%{_libdir}
make %{?jobs:-j%jobs}

%install
rm -rf $RPM_BUILD_ROOT
rm -r doc/quagga.info
make DESTDIR=$RPM_BUILD_ROOT install
rm -rf $RPM_BUILD_ROOT%{_libdir}/lib{ospf,zebra}.la
install -d $RPM_BUILD_ROOT/etc/{init.d,quagga,pam.d,logrotate.d}
install -m 755 init/SuSE/* $RPM_BUILD_ROOT/etc/init.d/
install -m 644 %{S:2} $RPM_BUILD_ROOT/etc/pam.d/quagga
install -d -m 750 $RPM_BUILD_ROOT/var/log/quagga
install -d -m 751 $RPM_BUILD_ROOT/var/run/quagga
install -m 644 redhat/quagga.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/quagga
ln -sf ../../etc/init.d/zebra $RPM_BUILD_ROOT/usr/sbin/rczebra
ln -sf ../../etc/init.d/bgpd $RPM_BUILD_ROOT/usr/sbin/rcbgpd
ln -sf ../../etc/init.d/ospf6d $RPM_BUILD_ROOT/usr/sbin/rcospf6d
ln -sf ../../etc/init.d/ospfd $RPM_BUILD_ROOT/usr/sbin/rcospfd
ln -sf ../../etc/init.d/ripngd $RPM_BUILD_ROOT/usr/sbin/rcripngd
ln -sf ../../etc/init.d/ripd $RPM_BUILD_ROOT/usr/sbin/rcripd
rm -f $RPM_BUILD_ROOT/etc/quagga/*.sample*
cat > $RPM_BUILD_ROOT/etc/quagga/zebra.conf << __EOF__
hostname quagga
password quagga
enable password quagga
log file /var/log/quagga/quagga.log
__EOF__
touch $RPM_BUILD_ROOT/etc/quagga/vtysh.conf

%pre
/usr/sbin/groupadd -r quagga 2> /dev/null || :
/usr/sbin/useradd -r -g quagga -s /bin/false \
                  -c "Quagga routing daemon" \
                  -d /var/run/quagga quagga 2> /dev/null || :

%post
%{fillup_and_insserv -n -s zebra zebra START_ZEBRA bgpd START_BGPD ospf6d START_OSPF6D ospfd START_OSPFD ripd START_RIP ripngd START_RIPNG}
%install_info --info-dir=%{_infodir} %{_infodir}/%{name}.info.gz

%preun
%{stop_on_removal zebra bgpd ospf6d ospfd ripd ripngd}

%postun
%install_info_delete --info-dir=%{_infodir} %{_infodir}/%{name}.info.gz
%{restart_on_update zebra bgpd ospf6d ospfd ripd ripngd}
%{insserv_cleanup}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc */*.sample* AUTHORS COPYING* ChangeLog NEWS README REPORTING-BUGS SERVICES TODO
/usr/sbin/*
%config /etc/quagga/
%config(noreplace) /etc/logrotate.d/*
%config /etc/init.d/*
%config (noreplace)/etc/pam.d/*
/usr/bin/*
%dir %attr(-,quagga,quagga) /var/log/quagga
%dir %attr(-,quagga,quagga) /var/run/quagga
%{_infodir}/quagga.info*
%{_mandir}/man?/*
%attr(755,root,root) %{_libdir}/lib*.so.*

%files devel
%defattr(644,root,root,755)
%{_libdir}/*.a
%{_libdir}/*.so
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/*.h
%dir %{_includedir}/%{name}/ospfd
%{_includedir}/%{name}/ospfd/*.h

%changelog
* Wed Nov 10 2010 prusnak@opensuse.org
- fixed CVE-2010-2948 and CVE-2010-2949 [bnc#634300]
* Thu May  7 2009 prusnak@suse.cz
- fixed crash (DoS) in BGP daemon via an ASN elements
  (bgpd-asn-dos.patch) [bnc#500540]
* Tue Jan  8 2008 prusnak@suse.cz
- fixed bad left shift (badshift.patch) [#351517]
* Tue Oct 30 2007 anosek@suse.cz
- updated Quagga to latest release (version 0.99.9) [#272057]
  * dropped obsolete patches: snmp.diff, netlink-fix.diff,
    strict-aliasing.diff, CVE-2006-2223-4.patch, bgpd-memleak.patch,
    CVE-2006-2276.patch, CVE-2007-1995.patch, qSLES10SP1-zrm.patch
  * fixed compiler warning (warnings.patch)
* Tue Apr 24 2007 anosek@suse.cz
- fixed VUL-0: quagga DoS [#266100] (CVE-2007-1995.patch)
* Tue Dec 19 2006 anosek@suse.cz
- Added a new feature for the zebra routing daemon
  to allow setting source addresses on routes installed by zebra.
  [#217090] (qSLES10SP1-zrm.patch)
* Wed May 17 2006 mmarek@suse.cz
- fixed memory leak in bgpd
  [http://bugzilla.quagga.net/show_bug.cgi?id=89] (bgpd-memleak.patch)
- fixed possible endless loop in bgpd caused by invalid vtysh commands
  [#173828#c4] (CVE-2006-2276.patch)
* Fri May 12 2006 mmarek@suse.cz
- fixed ripd not configurable to protect routing table from
  malicious updates (CVE-2006-2223, CVE-2006-2224)
  [#173828] (CVE-2006-2223-4.patch)
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Jan 24 2006 mmarek@suse.cz
- use $RPM_OPT_FLAGS (missing backslash)
- check for /proc/net/{dev,route,snmp} before build
* Tue Nov 22 2005 mmarek@suse.cz
- don't try to create fake directories under /proc (we don't build
  as root since Fri Jan 16 13:23:46 CET 2004), but print an error
  instead.
* Tue Oct 11 2005 mmarek@suse.cz
- better strict aliasing fix
* Mon Oct 10 2005 mmarek@suse.cz
- update to 0.98.5
* Tue Sep 20 2005 mmarek@suse.cz
- fixx gcc warnings
* Mon Aug  1 2005 anicka@suse.cz
- update to 0.98.4
* Tue Apr 19 2005 postadal@suse.de
- updated to version 0.98.3
- removed obsoleted patch config.diff
- use parallel make
* Thu Jan 13 2005 postadal@suse.cz
- updated to version 0.98.0
  * some commands may have been removed or have had their syntax changed
- removed obsoleted patch gcc-warnings-fix.diff
* Fri Nov 26 2004 postadal@suse.cz
- fixed lib64 path
* Thu Nov 25 2004 postadal@suse.cz
- updated to version 0.97.3
- fixed gcc warnings
- created subpackage "quagga-devel"
* Wed Aug 11 2004 postadal@suse.cz
- updated to version 0.96.5
* Thu Jun 17 2004 postadal@suse.cz
- enabled multipath for High Availability scenario [#41789]
* Wed Feb 11 2004 postadal@suse.cz
- updated to version 0.96.4
- fixed instalation problems [#33015]
- added quagga user/group
- removed obsoleted patch vty_telnet_option-fix
* Mon Jan 19 2004 postadal@suse.cz
- fixed security bug [#33993] (CAN-2003-0858): local users could send malicious
  netlink messages that cause DoS condition
- fixed DoS condition, which exists in zebra when layer 3 access is possible
  to the telnet management port 2601/tcp. (CAN-2003-0795) [#32656]
* Fri Jan 16 2004 kukuk@suse.de
- Add pam-devel to neededforbuild
- Build as user
* Mon Nov 10 2003 ro@suse.de
- use net-snmp instead of ucdsnmp
* Fri Nov  7 2003 postadal@suse.cz
- fixed DoS condition, which exists in zebra when layer 3 access is possible
  to the telnet management port 2601/tcp. (CAN-2003-0795) [#32656]
* Tue Aug 26 2003 postadal@suse.cz
- updated to bugfix version 0.96.2
  * fixed a small but very annoying ospfd bug
  * command.c newline fix
* Mon Aug 25 2003 postadal@suse.cz
- Zebra-pj has now forked from GNU Zebra. The new name is Quagga.
- update to version 0.96.1
- use new stop_on_removal/restart_on_upate macros
* Mon Jul 28 2003 postadal@suse.cz
- fixed ripngd init script [#27097]
* Fri Jul 25 2003 mludvig@suse.cz
- Update to Paul Jakma's Zebra fork. This is the only
  Zebra version currently maintained.
* Thu Apr 24 2003 ro@suse.de
- fix install_info --delete call and move from preun to postun
* Wed Feb 12 2003 mmj@suse.de
- Use %%install_info macro [#23478]
* Wed Nov 27 2002 postadal@suse.cz
- added kame-fix patch of mludvig@suse.cz
- bzipped source and rc.* moved to rc.tar.bz2 (init/SuSE/*)
* Thu Sep 26 2002 mludvig@suse.cz
- Upgrade to zebra-0.93b
- Added pam script
* Fri Aug 16 2002 postadal@suse.cz
- added %%insserv_prereq and %%fillup_prereq to PreReq [#18024]
* Sat Jul 27 2002 adrian@suse.de
- do not source rc.config
* Wed May 15 2002 schwab@suse.de
- Use autoreconf.
* Mon Feb 25 2002 postadal@suse.cz
- modified copyright of files in /etc/init.d
* Thu Jan 10 2002 egmont@suselinux.hu
- changed /sbin/init.d to /etc/init.d in init script comments
* Tue Dec 11 2001 cihlar@suse.cz
- removed START_* variables
- fixed init scripts to fit skeleton
- fixed file list
* Tue Nov  6 2001 cihlar@suse.cz
- fixed to compile with automake 1.5
* Mon Aug 27 2001 dan@suse.cz
- update to 0.92a release
  * Fix community-list "^$" matching bug
  * -lsnmp check problem fixed
- build root added, spec file clean-up
- installing info pages fixed
* Tue Aug 14 2001 ro@suse.de
- up to 0.91a and fixed for current autoconf
* Mon May 14 2001 lmuelle@suse.de
- fix typo in ripd startscript
- bzip2 sources
* Tue May  8 2001 strbac@suse.de
- remove init scripts and symlinks for vtysh (it's not a daemon)
* Thu Feb 22 2001 ro@suse.de
- added readline/readline-devel to neededforbuild (split from bash)
* Wed Jan 17 2001 bk@suse.de
- updated to 0.90a, fixes serious bug of bgpd when receiving routes
- fixed a bug in configure(.in) to detect *-suse-linux as linux
- replaced ipv6 configure diff with the configure option --enable-ipv6
- call autoconf to generate the fixed confgure (never patch configure)
- set CFLAGS to RPM_OPT_FLAGS for configure
- folded up configure argument list to make it more readable
* Thu Jan 11 2001 smueller@suse.de
- make it compile with IPv6 even if there is no IPv6 in the
  running kernel
* Thu Jan 11 2001 smueller@suse.de
- update to zebra 0.90
- enabled snmp support
* Thu Dec 21 2000 smueller@suse.de
- rc.config injection corrected
* Wed Dec 20 2000 smueller@suse.de
- changed absolut path names to relative in %%post
* Tue Dec  5 2000 bjacke@suse.de
- bzipped sources
- cleaned up spec file
- enabled IPv6 support
* Mon Dec  4 2000 smueller@suse.de
- initial version for 7.1
